/***    OEMHLP.H
 *
 *      OEMHLP Exported Definitions
 *      Copyright (c) IBM Corporation 1996
 *
 *      MODIFICATION HISTORY
 *      07/17/1996  KAZZ    Created.
 *      07/24/1996  KAZZ    Added DD name and OEMHLP_DBCS_HWSCROLL
 *      09/13/1996  E.Akahane Replace function number 12 and 13. ;@IBMj-ea833
 *                          defects: 833j, 168496
 */

/*
**      OEMHLP Support Device Driver Name
*/

#define OEMHLP_PDD_NAME         "OEMHLP$"

/*
**      OEMHLP Category Code
*/

#define OEMHLP_CATEGORY     0x80

/*
**      OEMHLP Main Function Codes
*/

#define OEMHLP_DOS_INFO          0      // return DOS information
#define OEMHLP_MACHINE_INFO      1      // return machine information
#define OEMHLP_CHECK_VIDEO       2      // return display combination code
#define OEMHLP_FONTS             3      // return the pointers to fonts
#define OEMHLP_EISA_CALL         4      // return EISA information
#define OEMHLP_BIOS_INFO         5      // return BIOS information
#define OEMHLP_MISC_INFO         6      // return Misc. State information
#define OEMHLP_VIDEO_ADAPTER     7      // return adapter type combinations
#define OEMHLP_SVGA_INFO         8      // return SVGA information
#define OEMHLP_MEMORY_INFO       9      // return Memory Information
#define OEMHLP_DMQS_GLOBAL_SEL  10      // return DMQS Global Selector
#define OEMHLP_PCI_CALL         11      // return PCI information
//@IBMj-ea833 swap the number of 12 and 13. VSVGA code in DEVCON#4 call 12.
#define OEMHLP_DBCS_INFO        12      // retuen DBCS unique information
#define OEMHLP_MACHINE_ID       13      // return machine ID byte

/*
**      OEMHLP Sub-Functions
*/

/* for OEMHLP_EISA_CALL */
#define OEMHLP_EISA_SLOTINFO     0      // get EISA slot information
#define OEMHLP_EISA_FUNCINFO     1      // get EISA function information

/* for OEMHLP_PCI_CALL */
#define OEMHLP_PCI_BIOSINFO      0      // PCI BIOS presence check
#define OEMHLP_PCI_FINDDEVICE    1      // find PCI device
#define OEMHLP_PCI_FINDCLASSCODE 2      // find class code
#define OEMHLP_PCI_READCONFIG    3      // read configuration space
#define OEMHLP_PCI_WRITECONFIG   4      // write configuration space

/* for OEMHLP_DBCS_INFO */
#define OEMHLP_DBCS_HWSCROLL     0      // return video H/W scroll capability
#define OEMHLP_DBCS_FONTGDTS     1      // return GDTs for DBCS fonts
#define OEMHLP_DBCS_INT10VECTOR  2      // return original INT 10h vector

/* End of OEMHLP.H */
