/****************************** Module Header ******************************\
*
* Module Name: PMPIC.H
*
* OS/2 Presentation Manager Picture functions include file.
*
* Copyright (c) International Business Machines Corporation 1981, 1988-1992
*
* ===========================================================================
*
* Comments at the end of each typedef line give the name tags used in
* the assembler include version of this file.
*
* The assembler include version of this file excludes lines between XLATOFF
* and XLATON comments.
*
#ifndef __IBMC__
   * The public version of this file (as shipped with the OS/2 Toolkit
   * product) excludes all non 32-bit material marked in this file
   * as well as any areas specifically marked with __IBMC__ conditional
   * sections - including this paragraph. The H2IBMH rexx command file
   * removes these sections.
#endif
\***************************************************************************/

/* XLATOFF */
#if __IBMC__ || __IBMCPP__
   #pragma info( none )
      #ifndef __CHKHDR__
         #pragma info( none )
      #endif
   #pragma info( restore )
#endif
/* XLATON */

#define PIC_INCLUDED

#ifndef INCL_32         /* If neither INCL_32 or INCL_16 set already */
   #ifndef INCL_16      /* find out from compiler if 32-bit or not.  */
     #ifdef M_I386
        #define INCL_32 /* Compiling for 32-bit */
     #else
        #define INCL_16 /* Compiling for 16-bit */
     #endif
  #endif
#endif

#ifdef INCL_16
   /* XLATOFF */
   #define PicPrint Pic16Print
   #define PicIchg Pic16Ichg
   #define PrfPif2Met Prf16Pif2Met
   /* XLATON */
#endif /* INCL_16 */

#ifndef __IBMC__
/* This stuff is private, should not be here. As a temporary HACK     */
/* place it within a not-IBMC bracket so that it is excluded from the */
/* toolkit                                                            */
typedef struct _METPARAMS {  /* metp */
   PSZ read_filename;
   PSZ write_filename;
   LONG EbcdicCP;
   LONG D_EbcdicCP;
   LONG SymSetNameCP;
   LONG AsciiCP;
   LONG Options;
} METPARAMS;
typedef METPARAMS FAR *PMETPARAMS;
#endif

/*** type of picture to print **********************************************/
#define PIP_MF       1L
#define PIP_PIF      2L

/*** type of conversion required *******************************************/
#define PIC_PIFTOMET 0L
#define PIC_SSTOFONT 2L

BOOL APIENTRY PicPrint(HAB hab,
                       PSZ pszFilename,
                       LONG lType,
                       PSZ pszParams);

BOOL APIENTRY PicIchg(HAB hab,
                      PSZ pszFilename1,
                      PSZ pszFilename2,
                      LONG lType);

#ifndef __IBMC__
/* This stuff is private, should not be here. As a temporary HACK     */
/* place it within a not-IBMC bracket so that it is excluded from the */
/* toolkit                                                            */
BOOL APIENTRY PrfPif2Met(HAB hab,
                         USHORT whatisthis,
                         PMETPARAMS metParams);
#endif

/* XLATOFF */
#if __IBMC__ || __IBMCPP__
   #pragma info( none )
      #ifndef __CHKHDR__
         #pragma info( restore )
      #endif
   #pragma info( restore )
#endif
/* XLATON */

/**************************** end of file **********************************/
